com.google.common.collect

## Class ForwardingSetMultimap<K,V>

- java.lang.Object
- - com.google.common.collect.ForwardingObject
  - - com.google.common.collect.ForwardingMultimap<K,V>
    - - com.google.common.collect.ForwardingSetMultimap<K,V>

- All Implemented Interfaces:
    Multimap<K,V>, SetMultimap<K,V>
  Direct Known Subclasses:
    ForwardingSortedSetMultimap

      @GwtCompatible
      public abstract class ForwardingSetMultimap<K,V>
      extends ForwardingMultimap<K,V>
      implements SetMultimap<K,V>

  A set multimap which forwards all its method calls to another set multimap. Subclasses should override one or more methods to modify the behavior of the backing multimap as desired per the decorator pattern.
  Since:
    3.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ForwardingSetMultimap()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected abstract SetMultimap<K,V>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
    `java.util.Set<java.util.Map.Entry<K,V>>` | `entries()` Returns a view collection of all key-value pairs contained in this multimap, as `Map.Entry` instances.
    `java.util.Set<V>` | `get(K key)` Returns a view collection of the values associated with `key` in this multimap, if any.
    `java.util.Set<V>` | `removeAll(java.lang.Object key)` Removes all values associated with the key `key`.
    `java.util.Set<V>` | `replaceValues(K key, java.lang.Iterable<? extends V> values)` Stores a collection of values with the same key, replacing any existing values for that key.

    - ### Methods inherited from class com.google.common.collect.ForwardingMultimap

      `asMap, clear, containsEntry, containsKey, containsValue, equals, hashCode, isEmpty, keys, keySet, put, putAll, putAll, remove, size, values`

    - ### Methods inherited from class com.google.common.collect.ForwardingObject

      `toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.common.collect.SetMultimap

      `asMap, equals`

    - ### Methods inherited from interface com.google.common.collect.Multimap

      `clear, containsEntry, containsKey, containsValue, hashCode, isEmpty, keys, keySet, put, putAll, putAll, remove, size, values`

- - ### Constructor Detail

    - #### ForwardingSetMultimap

          public ForwardingSetMultimap()

  - ### Method Detail

    - #### delegate

          protected abstract SetMultimap<K,V> delegate()

      Description copied from class: `ForwardingObject`
      Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.
      Specified by:
        `delegate` in class `ForwardingMultimap<K,V>`

    - #### entries

          public java.util.Set<java.util.Map.Entry<K,V>> entries()

      Description copied from interface: `Multimap`
      Returns a view collection of all key-value pairs contained in this multimap, as `Map.Entry` instances.

      Changes to the returned collection or the entries it contains will update the underlying multimap, and vice versa. However, adding to the returned collection is not possible.

      Specified by:
        `entries` in interface `Multimap<K,V>`
      Specified by:
        `entries` in interface `SetMultimap<K,V>`
      Overrides:
        `entries` in class `ForwardingMultimap<K,V>`

    - #### get

          public java.util.Set<V> get(@Nullable
                             K key)

      Description copied from interface: `Multimap`
      Returns a view collection of the values associated with `key` in this multimap, if any. Note that when `containsKey(key)` is false, this returns an empty collection, not `null`.

      Changes to the returned collection will update the underlying multimap, and vice versa.

      Specified by:
        `get` in interface `Multimap<K,V>`
      Specified by:
        `get` in interface `SetMultimap<K,V>`
      Overrides:
        `get` in class `ForwardingMultimap<K,V>`

    - #### removeAll

          public java.util.Set<V> removeAll(@Nullable
                                   java.lang.Object key)

      Description copied from interface: `Multimap`
      Removes all values associated with the key `key`.

      Once this method returns, `key` will not be mapped to any values, so it will not appear in `Multimap.keySet()`, `Multimap.asMap()`, or any other views.

      Specified by:
        `removeAll` in interface `Multimap<K,V>`
      Specified by:
        `removeAll` in interface `SetMultimap<K,V>`
      Overrides:
        `removeAll` in class `ForwardingMultimap<K,V>`
      Returns:
        the values that were removed (possibly empty). The returned collection may be modifiable, but updating it will have no effect on the multimap.

    - #### replaceValues

          public java.util.Set<V> replaceValues(K key,
                                       java.lang.Iterable<? extends V> values)

      Description copied from interface: `Multimap`
      Stores a collection of values with the same key, replacing any existing values for that key.

      If `values` is empty, this is equivalent to `removeAll(key)`.

      Specified by:
        `replaceValues` in interface `Multimap<K,V>`
      Specified by:
        `replaceValues` in interface `SetMultimap<K,V>`
      Overrides:
        `replaceValues` in class `ForwardingMultimap<K,V>`
      Returns:
        the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.